<?php
/*
This script is designed to be run from wordpress. It will work if placed in the root directory of a wordpress install.
Version: 1.1

*/

//Run this to create an entry for a post in the voting system. Will check if the post exists. If it doesn't, it will create an entry.
function SetPost($post_ID) {
	global $wpdb;
	
	//prevents SQL injection
	$p_ID = $wpdb->escape($post_ID);

	//Check if entry exists
	$id_raw = $wpdb->get_var("SELECT ID FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	if ($id_raw != '') {
		//entry exists, do nothing
	} else {
		//entry does not exist
		$wpdb->query("INSERT INTO ".$wpdb->prefix."votes (post, votes, guests, usersinks, guestsinks) VALUES(".$p_ID.", '', '', '', '') ") or die(mysql_error());
	}
}

//Run this to create an entry for a user in the voting system. Will check if the user exists. If it doesn't, it will create an entry.
function SetUser($user_ID) {
	global $wpdb;
	
	//prevents SQL injection
	$u_ID = $wpdb->escape($user_ID);

	//Check if entry exists
	$id_raw = $wpdb->get_var("SELECT ID FROM ".$wpdb->prefix."votes_users WHERE user='".$u_ID."'");
	if ($id_raw != '') {
		//entry exists, do nothing
	} else {
		//entry does not exist
		$wpdb->query("INSERT INTO ".$wpdb->prefix."votes_users (user, votes, sinks) VALUES(".$u_ID.", '', '') ") or die(mysql_error());
	}
}

//Returns the vote count
function GetVotes($post_ID) {
	global $wpdb;
	
	//prevents SQL injection
	$p_ID = $wpdb->escape($post_ID);

	//Create entries if not existant
	SetPost($p_ID);

	//Gets the votes
	$votes_raw = $wpdb->get_var("SELECT votes FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$sinks_raw = $wpdb->get_var("SELECT usersinks FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$guestvotes_raw = $wpdb->get_var("SELECT guests FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$guestsinks_raw = $wpdb->get_var("SELECT guestsinks FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$uservotes_raw = $wpdb->get_var("SELECT votes FROM ".$wpdb->prefix."votes_users WHERE user='".$u_ID."'");
	$usersinks_raw = $wpdb->get_var("SELECT sinks FROM ".$wpdb->prefix."votes_users WHERE user='".$u_ID."'");

	//Put it in array form
	$votes = explode(",", $votes_raw);
	$sinks = explode(",", $sinks_raw);
	$guestvotes = explode(",", $guestvotes_raw);
	$guestsinks = explode(",", $guestsinks_raw);
	$uservotes = explode(",", $uservotes_raw);
	$usersinks = explode(",", $usersinks_raw);

	$initial = 0; //Initial no. of votes [will be placed at -1 when all posts receive votes]
	
	//The mathematics
	$votecount = count($votes) - count($sinks) + count($guestvotes) - count($guestsinks) + count($uservotes) - count($usersinks) + $initial;
	return $votecount;
}

function GetPostVotes($post_ID) {
	global $wpdb;
	
	//prevents SQL injection
	$p_ID = $wpdb->escape($post_ID);

	//Create entries if not existant
	SetPost($p_ID);

	//Gets the votes
	$votes_raw = $wpdb->get_var("SELECT votes FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");

	//Put it in array form
	$votes = explode(",", $votes_raw);
	return $votes;
}

function GetPostSinks($post_ID) {
	global $wpdb;
	
	//prevents SQL injection
	$p_ID = $wpdb->escape($post_ID);

	//Create entries if not existant
	SetPost($p_ID);

	//Gets the votes
	$sinks_raw = $wpdb->get_var("SELECT usersinks FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");

	//Put it in array form
	$sinks = explode(",", $sinks_raw);
	return $sinks;
}

//Returns a series of information
function GetBarVotes($post_ID) {
	global $max_displayed_votes, $votes_thershold;
	$votes = GetVotes($post_ID);
	$votemax = $max_displayed_votes;
	$votebreak = $votes_thershold;
	$bar[0] = 0; //The length of the bar
	$bar[1] = 0; //The state of the bar
	if ($votes > $votemax && $votes > -1) {
		$bar[0] = $votemax;
	} else {
		if ($votes > -1) {
			$bar[0] = $votes;
		} else {
			$bar[0] = 0;
		}
	}
	if ($votes > $votebreak) {
		$bar[1] = 1;
	}
	return $bar;
}

//Checks if the user voted
function UserVoted($post_ID, $user_ID) {
	global $wpdb;
	
	//prevents SQL injection
	$p_ID = $wpdb->escape($post_ID);
	$u_ID = $wpdb->escape($user_ID);

	//Create entry if not existant
	SetPost($p_ID);

	//Gets the votes
	$votes_raw = $wpdb->get_var("SELECT votes FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$sinks_raw = $wpdb->get_var("SELECT usersinks FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");

	//Put it in array form
	$votes = explode(",", $votes_raw);
	$sinks = explode(",", $sinks_raw);
	
	$voted = FALSE;
	$votekey = array_search($u_ID, $votes);
	$sinkkey = array_search($u_ID, $sinks);
	if ($votekey != '' | $sinkkey != '') {
		$voted = TRUE;
	}
	return $voted;
}

//Checks if the visitor voted
function GuestVoted($post_ID, $user_IPhash) {
	global $wpdb;
	
	//prevents SQL injection
	$p_ID = $wpdb->escape($post_ID);
	$u_ID = $wpdb->escape($user_IPhash);

	//Create entry if not existant
	SetPost($p_ID);

	//Gets the votes
	$votes_raw = $wpdb->get_var("SELECT guests FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$sinks_raw = $wpdb->get_var("SELECT guestsinks FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");

	//Put it in array form
	$votes = explode(",", $votes_raw);
	$sinks = explode(",", $sinks_raw);
	
	$voted = FALSE;
	$votekey = array_search($u_ID, $votes);
	$sinkkey = array_search($u_ID, $sinks);
	if ($votekey != '' | $sinkkey != '') {
		$voted = TRUE;
	}
	return $voted;
}

//Checks the key to see if it is valid
function CheckKey($key, $id) {
	global $wpdb;
	$userdata = $wpdb->get_results("SELECT display_name, user_email, user_url, user_registered FROM $wpdb->users WHERE ID = '".$id."'", ARRAY_N);
	$chhash = md5($userdata[0][0].$userdata[0][3]);
	if ($chhash == $key) {
		return TRUE;
	} else {
		return FALSE;
	}
}

//Saves the vote of a user to the database
function Vote($post_ID, $user_ID, $type) {
	global $wpdb;
	
	//Prevents SQL injection
	$p_ID = $wpdb->escape($post_ID);
	$u_ID = $wpdb->escape($user_ID);

	//Create entries if not existant
	SetPost($p_ID);
	SetUser($u_ID);

	//Gets the votes
	$votes_raw = $wpdb->get_var("SELECT votes FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$sinks_raw = $wpdb->get_var("SELECT usersinks FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$uservotes_raw = $wpdb->get_var("SELECT votes FROM ".$wpdb->prefix."votes_users WHERE user='".$u_ID."'");
	$usersinks_raw = $wpdb->get_var("SELECT sinks FROM ".$wpdb->prefix."votes_users WHERE user='".$u_ID."'");
	
	//Gets the votes in array form
	$votes = explode(",", $votes_raw);
	$sinks = explode(",", $sinks_raw);
	$uservotes = explode(",", $uservotes_raw);
	$usersinks = explode(",", $usersinks_raw);

	//Check if user voted
	if (!UserVoted($post_ID,$user_ID)) {
	//user hasn't vote, so the script allows the user to vote

		if ($type != 'sink') {
			//Add vote to array
			$user_var[0] = $u_ID;
			$post_var[0] = $p_ID;
			$votes_result = array_merge($votes,$user_var);
			$votes_result_raw = implode(",",$votes_result);
			$uservotes_result = array_merge($uservotes,$post_var);
			$uservotes_result_raw = implode(",",$uservotes_result);
			$sinks_result_raw = $sinks_raw;
			$usersinks_result_raw = $usersinks_raw;
		} else {
			//Add sink to array
			$user_var[0] = $u_ID;
			$post_var[0] = $p_ID;
			$sinks_result = array_merge($sinks,$user_var);
			$sinks_result_raw = implode(",",$sinks_result);
			$usersinks_result = array_merge($usersinks,$post_var);
			$usersinks_result_raw = implode(",",$usersinks_result);
			$votes_result_raw = $votes_raw;
			$uservotes_result_raw = $votesinks_raw;
		}
		
		//Prevents SQL injection
		$votes_result_sql = $wpdb->escape($votes_result_raw);
		$sinks_result_sql = $wpdb->escape($sinks_result_raw);
		$uservotes_result_sql = $wpdb->escape($uservotes_result_raw);
		$usersinks_result_sql = $wpdb->escape($usersinks_result_raw);
		
		//Update votes
		$wpdb->query("UPDATE ".$wpdb->prefix."votes SET votes='".$votes_result_sql."' WHERE post='".$p_ID."'");
		$wpdb->query("UPDATE ".$wpdb->prefix."votes SET usersinks='".$sinks_result_sql."' WHERE post='".$p_ID."'");
		$wpdb->query("UPDATE ".$wpdb->prefix."votes_users SET votes='".$uservotes_result_sql."' WHERE user='".$u_ID."'");
		$wpdb->query("UPDATE ".$wpdb->prefix."votes_users SET sinks='".$usersinks_result_sql."' WHERE user='".$u_ID."'");
		
		$result = 'true';
	} else {
		//The user voted, thus the script will not update the votes in the article
		$result = 'false';
	}

	return $result; //returns '' on failure, returns 'true' if votes were casted, returns 'false' if user already casted a vote
}

//Saves the vote of a guest to the database
function GuestVote($post_ID, $type) {
	global $wpdb;
	
	//Guest's vote is stored permanently. May implement votes that will expire.
	//Use user IP
	$iphash = md5($_SERVER['REMOTE_ADDR']);

	//Set a cookie if there isn't any. This is to reduce the problem of users using proxies and voting multiple times on the same stories.
/*
	if(isset($_COOKIE['tevinevotes'])) {
		$iphash = $_COOKIE['tevinevotes']; 
	} else {
		$cookielife = 14 * 60 * 24 * 60 + time(); //Set to expire in a year from now
		setcookie('tevinevotes', $iphash, $cookielife);
	}
*/	

	//Prevents SQL injection
	$u_ID = $wpdb->escape($iphash);
	$p_ID = $wpdb->escape($post_ID);

	//Create entries if not existant
	SetPost($p_ID);

	//Gets the info
	$votes_raw = $wpdb->get_var("SELECT guests FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$sinks_raw = $wpdb->get_var("SELECT guestsinks FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	
	//Gets the votes in array form
	$votes = explode(",", $votes_raw);
	$sinks = explode(",", $sinks_raw);

	//Check if user voted
	if (!GuestVoted($post_ID,$user_ID)) {
	//user hasn't vote, so the script allows the user to vote

		if ($type != 'sink') {
			//Add vote to array
			$user_var[0] = $u_ID;
			$post_var[0] = $p_ID;
			$votes_result = array_merge($votes,$user_var);
			$votes_result_raw = implode(",",$votes_result);
			$sinks_result_raw = $sinks_raw;
		} else {
			//Add sink to array
			$user_var[0] = $u_ID;
			$post_var[0] = $p_ID;
			$sinks_result = array_merge($sinks,$user_var);
			$sinks_result_raw = implode(",",$sinks_result);
			$votes_result_raw = $votes_raw;
		}
		
		//Prevents SQL injection
		$votes_result_sql = $wpdb->escape($votes_result_raw);
		$sinks_result_sql = $wpdb->escape($sinks_result_raw);
		
		//Update votes
		$wpdb->query("UPDATE ".$wpdb->prefix."votes SET guests='".$votes_result_sql."' WHERE post='".$p_ID."'");
		$wpdb->query("UPDATE ".$wpdb->prefix."votes SET guestsinks='".$sinks_result_sql."' WHERE post='".$p_ID."'");
		
		$result = 'true';
	} else {
		//The user voted, thus the script will not update the votes in the article
		$result = 'false';
	}

	return $result; //returns '' on failure, returns 'true' if votes were casted, returns 'false' if user already casted a vote
}

/*
function SortVotes() {

	global $wpdb;
	
	//prevents SQL injection
	//$p_ID = $wpdb->escape($post_ID);

	//Create entries if not existant
	//SetPost($p_ID);

//Get posts logged
$posts = $wpdb->get_results("SELECT post FROM ".$wpdb->prefix."votes WHERE ID != ''");

$postarray = array();

foreach ($posts as &$post) { 
$p_ID = $post->post;

	//Gets the votes
	$votes_raw = $wpdb->get_var("SELECT votes FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$sinks_raw = $wpdb->get_var("SELECT usersinks FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$guestvotes_raw = $wpdb->get_var("SELECT guests FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
	$guestsinks_raw = $wpdb->get_var("SELECT guestsinks FROM  ".$wpdb->prefix."votes WHERE post='".$p_ID."'");

	//Put it in array form
	$votes = explode(",", $votes_raw);
	$sinks = explode(",", $sinks_raw);
	$guestvotes = explode(",", $guestvotes_raw);
	$guestsinks = explode(",", $guestsinks_raw);

	$initial = 0; //Initial no. of votes [will be placed at -1 when all posts receive votes]
	
	//The mathematics
	$votecount = count($votes) - count($sinks) + count($guestvotes) - count($guestsinks) + $initial;
array_push($postarray, array($p_ID,$votecount));
}

	return $postarray;

}
*/

/* provided by developers ( http://forums.tevine.com/viewtopic.php?f=12&t=6#p19 ) */
function SortVotes() {

global $wpdb;

//prevents SQL injection
//$p_ID = $wpdb->escape($post_ID);

//Create entries if not existant
//SetPost($p_ID);

//Get posts logged
$posts = $wpdb->get_results("SELECT post FROM ".$wpdb->prefix."votes WHERE ID != ''");

$postarray = array();

foreach ($posts as $post) {
$p_ID = $post->post;

//Gets the votes
$votes_raw = $wpdb->get_var("SELECT votes FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
$sinks_raw = $wpdb->get_var("SELECT usersinks FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
$guestvotes_raw = $wpdb->get_var("SELECT guests FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");
$guestsinks_raw = $wpdb->get_var("SELECT guestsinks FROM ".$wpdb->prefix."votes WHERE post='".$p_ID."'");

//Put it in array form
$votes = explode(",", $votes_raw);
$sinks = explode(",", $sinks_raw);
$guestvotes = explode(",", $guestvotes_raw);
$guestsinks = explode(",", $guestsinks_raw);

$initial = 0; //Initial no. of votes [will be placed at -1 when all posts receive votes]

//The mathematics
$votecount = count($votes) - count($sinks) + count($guestvotes) - count($guestsinks) + $initial;
array_push($postarray, array($p_ID,$votecount));
}

return $postarray;

}

/* provided by developers ( http://forums.tevine.com/viewtopic.php?f=12&t=6#p19 ) */

/* Added by Graf ( http://thexnews.com/?p=108 ) */
function VoteAdmin()
{
?>
  <div>
    <h3>Ratings</h3>
    <ul>
<?php
$votearr=SortVotes();   //Getting all that stuff
$votenew=$votearr;


for ($votei=0; $votei<count($votearr); $votei++)  //Converting in normal array
  {$votenormal[$votei]=implode("a",$votearr[$votei]);}

if (get_option("vote_backup")!="")
  {
   $votearr=explode("b",get_option("vote_backup")); //Getting previosly saved array
   $votenew=array_diff($votenormal,$votearr);  //looking for diffs

   $votearr=explode("b",get_option("recent_votes"));
   $votearr=array_merge($votenew,$votearr);
   $votearr=array_slice($votearr, 0,5);

   update_option("recent_votes",implode("b",$votearr));
  }

   update_option("vote_backup",implode("b",$votenormal)); //Saving new array   


foreach ($votearr as $votei)     //printing differences...
 {
  $votetmp=explode("a",$votei);
  echo "<li><a href=".get_permalink($votetmp[0]).">".get_the_title($votetmp[0])."</a> (".$votetmp[1].")</li>";
 }


?>
  </ul>
</div>


<?php
}

function VoteThumbUpInit()
{
?>
<div style="visibility:hidden; position:absolute;">
<script type="text/javascript">
  function chbg(el, bg) {document.getElementById(el).style.backgroundImage="url('<?php bloginfo('url'); ?>/wp-content/plugins/voteitup/"+bg+"')";}
  function votehide(el) {document.getElementById(el).style.visibility='hidden';}
  function voteshow(el,s) {
	document.getElementById(el).style.visibility='visible';
	  if (s=='relative') {document.getElementById(el).style.position='relative';}
	}
</script>

<img src="<?php bloginfo('url'); ?>/wp-content/plugins/voteitup/vote2.png" alt=""/>
<img src="<?php bloginfo('url'); ?>/wp-content/plugins/voteitup/vote3.png" alt=""/>
</div>

<?php
}


function VoteThumbUp($vp1)
{
if (($vp1==0) or (single_post_title('prefix', false)!=""))
{
?> 
   <div style="text-align:center">
     <div id="votec<?php the_ID(); ?>" class="voterate"><b>Рейтинг поста: <span class="tickercontainer"  style="" id="votes<?php the_ID(); ?>"><?php echo GetVotes(get_the_ID()); ?></span></b></div>
     <?php global $user_ID; if(!UserVoted(get_the_ID(),$user_ID) && !GuestVoted(get_the_ID(),md5($_SERVER['REMOTE_ADDR']))) { ?>
	<span id="voteid<?php the_ID(); ?>">
	  <span class="storytitle">Как вам пост?</span>
	  <span class="votebg" style="margin:auto;"><span class="votebg" id="votebg_<?php the_ID() ?>" onmouseout="chbg('votebg_<?php the_ID() ?>','vote1.png');">
	    <a href="javascript:vote_ticker(<?php the_ID() ?>,<?php the_ID() ?>,<?php if ($user_ID != '') { echo $user_ID; } else { echo 0; } ?>,'<?php bloginfo('url'); ?>');">
		<span class="vote" title="Понравился ;)" onmouseover="chbg('votebg_<?php the_ID() ?>','vote2.png');" onclick="voteshow('votec<?php the_ID(); ?>','relative'); votehide('voteid<?php the_ID(); ?>');">
                  
		</span></a>
	    <a href="javascript:sink_ticker(<?php the_ID() ?>,<?php the_ID() ?>,<?php if ($user_ID != '') { echo $user_ID; } else { echo 0; } ?>,'<?php bloginfo('url'); ?>');">
		<span class="vote" style="float:right;" title="Не понравился >>--:(-->" onmouseover="chbg('votebg_<?php the_ID() ?>','vote3.png');" onclick="voteshow('votec<?php the_ID(); ?>','relative'); votehide('voteid<?php the_ID(); ?>');">

		</span></a>
	  </span></span>
	</span>
     <?php } else {echo "<script>voteshow('votec"; the_ID(); echo "','relative');</script>"; } ?>
     <a href="#respond">Комментировать...</a>
   </div>
<?}

}

/* Added by Graf ( http://thexnews.com/?p=108 ) */
?>
